/*
** Compares recovered ROM with known "good" sources.
**
** by Oscar Toledo G.
**
** Creation date: Aug/07/2024.
*/

#include <stdio.h>

unsigned char rom3[8192];
unsigned char rom4[8192];

unsigned char final[8192];

/*
** Main program
*/
int main(void)
{
	FILE *input;
	FILE *output;
	int c;

	input = fopen("_2009-01-12_cpu_4k.bin", "rb");
	fread(rom3, 1, 2048, input);
	fread(rom3 + 4096, 1, 2048, input);
	fclose(input);
    input = fopen("_2009-10-18_cpu_bad8k_2_2564.bin", "rb");
    fread(rom4, 1, sizeof(rom4), input);
    fclose(input);
    input = fopen("recover.rom", "rb");
    fread(final, 1, 8192, input);
    fclose(input);

    fprintf(stderr, "Comparison against 4k.bin\n");
	for (c = 0; c < 8192; c++) {
        if ((c >= 0x1000 && c < 0x1800)) {    /* Fix using known good data */
            if ((final[c] & 0xfd) != (rom3[c] & 0xfd)) {
                fprintf(stderr, "There is a difference at $%04x (original $%04x vs new $%04x)\n",
                        c, rom3[c], final[c]);
            }
        }
	}
    fprintf(stderr, "Comparison against 2564.bin\n");
    for (c = 0; c < 8192; c++) {
        if ((final[c] & 0xbd) != (rom4[c] & 0xbd)) {
            fprintf(stderr, "There is a difference at $%04x (original $%04x vs new $%04x)\n",
                    c, rom4[c], final[c]);
        }
    }
}
